"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function stateFactory(module) {
    const state = new (module.prototype.constructor)({});
    const s = {};
    Object.keys(state).forEach((key) => {
        if (['actions', 'getters', 'mutations', 'modules', 'state', 'namespaced'].indexOf(key) !== -1) {
            // These are reserved keys, cannot use these
            return;
        }
        if (state.hasOwnProperty(key)) {
            if (typeof state[key] !== 'function') {
                s[key] = state[key];
            }
        }
    });
    return s;
}
exports.stateFactory = stateFactory;
//# sourceMappingURL=stateFactory.js.map