"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function staticStateGenerator(module, modOpt, statics) {
    Object.keys(module.state).forEach((key) => {
        if (module.state.hasOwnProperty(key)) {
            // If not undefined or function means it is a state value
            if (['undefined', 'function'].indexOf(typeof module.state[key]) === -1) {
                Object.defineProperty(statics, key, {
                    get() {
                        return modOpt.store.state[modOpt.name][key];
                    }
                });
            }
        }
    });
}
exports.staticStateGenerator = staticStateGenerator;
function staticGetterGenerator(module, modOpt, statics) {
    Object.keys(module.getters).forEach((key) => {
        if (module.namespaced) {
            Object.defineProperty(statics, key, {
                get() {
                    return modOpt.store.getters[`${modOpt.name}/${key}`];
                }
            });
        }
        else {
            Object.defineProperty(statics, key, {
                get() {
                    return modOpt.store.getters[key];
                }
            });
        }
    });
}
exports.staticGetterGenerator = staticGetterGenerator;
function staticMutationGenerator(module, modOpt, statics) {
    Object.keys(module.mutations).forEach((key) => {
        if (module.namespaced) {
            statics[key] = function (...args) {
                modOpt.store.commit(`${modOpt.name}/${key}`, ...args);
            };
        }
        else {
            statics[key] = function (...args) {
                modOpt.store.commit(key, ...args);
            };
        }
    });
}
exports.staticMutationGenerator = staticMutationGenerator;
function staticActionGenerators(module, modOpt, statics) {
    Object.keys(module.actions).forEach((key) => {
        if (module.namespaced) {
            statics[key] = function (...args) {
                return __awaiter(this, void 0, void 0, function* () {
                    return yield modOpt.store.dispatch(`${modOpt.name}/${key}`, ...args);
                });
            };
        }
        else {
            statics[key] = function (...args) {
                return __awaiter(this, void 0, void 0, function* () {
                    return yield modOpt.store.dispatch(key, ...args);
                });
            };
        }
    });
}
exports.staticActionGenerators = staticActionGenerators;
//# sourceMappingURL=staticGenerators.js.map